# -*- coding: utf-8 -*-
#! /usr/bin/python2.7
#----------------------------------------------------------------
# Dateiname: howbig.py
# Das RPi-Kameramodul ist angeschlossen.
# Das Programm ermöglicht das Ausmessen von Objekten auf dem Display.
# 
# Michael Weigend: Raspberry Pi programmieren mit Python, mitp 2013
# 10.10
# 29.10.2013
#----------------------------------------------------------------
import os, thread, math, time 
from Tkinter import Tk, Label, Radiobutton, StringVar
from PIL import Image, ImageTk
WIDTH, HEIGHT = 800, 600
BBOX = (200,150,600, 450)
PATH = '/home/pi/photos/image.jpg'

        
class App:  
    def __init__(self):
        # Widgets
        self.window = Tk()
        self.state = StringVar()
        self.labelImage = Label(master=self.window)
        self.labelImage.pack()
        self.label= Label(master=self.window, text = 'Auf den Anfang klicken')
        self.label.pack()
        self.measureRB = Radiobutton(master=self.window, text='Messen',
                             variable=self.state, value='Messen' )
        
        self.measureRB.select()
        self.measureRB.pack()
        self.calRB = Radiobutton(master=self.window, text='Kalibrieren',
                             variable=self.state, value='Kalibrieren' )
        self.calRB.deselect()
        self.calRB.pack()

        # Attribute
        self.p0 = ()
        self.factor = 1
        self.mouseBlocked = False
        
        # Operationen
        self.labelImage.bind('<1>', self.click)
        thread.start_new_thread(self.takePhotos, ())
        self.window.mainloop()
    
    def takePhotos (self):
        while True:
            command = 'raspistill -t 500 -w %s -h %s -o %s -n '
            os.system(command % (WIDTH, HEIGHT, PATH))
            self.image = Image.open(PATH).crop(BBOX)   #
            self.pImage=ImageTk.PhotoImage(self.image)    
            self.labelImage.config(image=self.pImage)
            time.sleep(1)

    def reset(self):
        self.p0 = ()
        self.label.config(text='Auf den Anfang klicken')  

    def click(self, event):
        if self.mouseBlocked: return
        self.mouseBlocked = True
        if not self.p0:
            self.p0 = event.x, event.y
            self.label.config(text='Auf das Ende klicken')
        else:
            x0, y0 = self.p0
            x1, y1 = event.x, event.y
            d = math.sqrt((x1 - x0)**2 + (y1 - y0)**2)
            if self.state.get() == 'Kalibrieren':
                self.factor = 10/d
                print self.factor
                self.label.config(text='1 cm sind %.1f Pixel' % (1/self.factor))
            else:
                self.label.config(text='Länge %.2f cm' % (d * self.factor))
            self.window.after(5000, self.reset)
        self.mouseBlocked = False
            
                
App()                            
