#!/usr/bin/python3.2
#----------------------------------------------------------------
# Dateiname: options.py
# Das RPi-Kameramodul ist angeschlossen.
# Mit raspistill werden Fotos gemacht und dabei verschiedene
# Kameraoptionen verwendet.
#
# Michael Weigend: Raspberry Pi programmieren mit Python, mitp 2013
# 10.3
# 29.10.2013
#----------------------------------------------------------------
import os
import time

BASEDIR = '/home/pi/photos/'
EX_LIST = ['off', 'auto', 'night']
AWB_LIST = ['off', 'auto', 'sun', 'cloud']

def deleteImages():
    try:
        os.remove('%simg_*.jpg' % BASEDIR)
    except: pass

def takePhoto(ex, awb):
    path = '%simg_%s_%s.jpg' % (BASEDIR, ex, awb)
    command = 'raspistill -t 0, -ex %s -awb %s -o %s -n'\
                         %(ex, awb, path)
    os.system(command)
    time.sleep(0.2)
    print("Foto mit ex=%s und awg=%s gespeichert." % (ex, awb))

print("Lösche alte Fotos")
deleteImages()
print("Starte Fotoserie...")
for ex in EX_LIST:
    for awb in AWB_LIST:
        takePhoto(ex, awb)
print("Fertig!")
          


