#----------------------------------------------------------------
# Dateiname: knock.py
# Klopfzeichen erkennen
#
# Michael Weigend: Raspberry Pi programmieren mit Python, mitp 2013
# 3.8.5
# 28.10.2013
#----------------------------------------------------------------

# knock.py
from RPi import GPIO
from time import sleep
GPIO.setwarnings(False)                              #1
GPIO.setmode(GPIO.BOARD)
GPIO.setup(10, GPIO.IN)      # Schalter
GPIO.setup(8, GPIO.OUT)      # LED
TIMEOUT = 3                                          #2
STEP = 0.01                                          #3
codes = [[1, 1, 1, 1],
    [1, 0, 0, 1, 2, 1],
    [1, 2, 1, 2, 1]
    [1, 1, 2, 0, 1, 0]]                              #4
GPIO.output(8, True)         # LED ausschalten
while True:
    knock = []
    while not GPIO.input(10):                        #5
        sleep(0.01)
    knocking = True
    while knocking:                                  #6
        t = 0
        while GPIO.input(10):                        #7
            sleep(STEP)
            t += STEP
        while not GPIO.input(10) and (t< TIMEOUT):
            sleep(STEP)                              #8
            t += STEP
        if t < TIMEOUT:                              #9
            knock.append(t)
        else:
            knocking = False
    a = knock[0]
    for i in range (len(knock)):
        knock[i] = round(knock[i] / a)               #10
    print('Klopfsignal:', knock)                     #11
    if knock in codes:                               #12
        GPIO.output(8, False)
        sleep(3)
        GPIO.output(8, True)    
    
